//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec2 uv1;
attribute vec2 uv2;

varying highp vec2 uv1Varying;
varying highp vec2 uv2Varying;
varying lowp float v_fog;
varying highp vec4 v_shadow_coord;

uniform float fogMult;
uniform mat4 mMatrix;
uniform mat4 vpMatrix;
uniform mat4 shadow_projection;

void main()
{

    uv1Varying = uv1;
    uv2Varying = uv2;
    gl_Position = vpMatrix * mMatrix * position;
    
    v_fog = STD_FOG(fogMult);
    
    v_shadow_coord = (shadow_projection * mMatrix * position);
}
