//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//


varying lowp vec2 frag_uv1;
varying lowp vec4 v_position;
varying lowp vec3 v_normal;
varying lowp float v_fog;
varying lowp vec4 colorVarying;
VARYING_MAT3(tangentSpace);
varying highp vec4 shadowCoord;

uniform sampler2D texture;
uniform sampler2D normalMap;
uniform SHADOW_SAMPLER_FD shadowMap;
uniform sampler2D gloss_map;
uniform samplerCube env_map;

uniform highp mat4 viewInverse;
uniform highp mat4 mMatrix;
uniform highp mat4 vpMatrix;
uniform highp mat3 normalMatrix;

uniform lowp vec3 light_dir;

uniform lowp float ambient_mult;
uniform lowp float diffuse_mult;

F_FOG_UNIFORMS


void main()
{

//    lowp float pixel_size = 1.0/2048.0;
    lowp vec3 lightColor = vec3(1.0, 0.93, 0.80);
    lowp vec4 result = texture2D(texture, frag_uv1);
    lowp float gloss = /*vec4(0.5, 0.5, 0.5, 1.0);*/texture2D(gloss_map, frag_uv1).x;
    lowp vec3 nm = normalize(texture2D(normalMap, frag_uv1).xyz*2.0 - 1.0).xyz;
    lowp float shadowVal = 0.0;
    highp vec4 m_shadow_coord = shadowCoord;
    shadowVal = CALC_SHADOW_VAL_FD(shadowMap, shadowCoord);
    gl_FragColor = result;
    
    
    mediump vec3 normalDirection = MAKE_MAT3_FROM_VARYING(tangentSpace) * nm;
//    lowp vec4 refl_color = textureCube(env_map, normalDirection);
    //mediump vec3 normalDirection = normalize(normalMatrix * v_normal);
    lowp vec3 lightDirection = -normalize(light_dir);
    mediump vec3 highlightDirection = normalize(vec3(-0.42, -0.75, -1.52));
    mediump vec3 viewDirection = normalize(vec3(viewInverse * vec4(0.0, 0.0, 0.0, 1.0) - mMatrix * v_position));
    
    lowp float nDotVP = max(0.0, dot(normalDirection, normalize(lightDirection)));
    lowp float fresnel = 1.0 - pow(dot(normalDirection, viewDirection), 1.0);
                 
    lowp vec3 specularReflection;

    specularReflection = lightColor * (2.0 + gloss*(12.0 + 8.0*fresnel)) * pow(max(0.0, dot(reflect(-lightDirection, normalDirection), viewDirection)), 2.0 + 10.0*gloss);
    lowp vec3 highlightSpecular = vec3(1.0, 0.2, 0.0) * gloss*(3.0 + 3.0*fresnel) * pow(max(0.0, dot(reflect(-highlightDirection, normalDirection), viewDirection)), 2.0 + 4.0*gloss);


    //lowp float refl_amt = gloss*fresnel;
    
    gl_FragColor.xyz = (gl_FragColor.xyz) * (vec3(0.9, 0.9, 1.0)*ambient_mult) + gl_FragColor.xyz*(nDotVP*lightColor*(1.8-gloss) + (specularReflection)*(0.7 + 2.5*gloss))*shadowVal;
//    gl_FragColor.xyz = vec3(gloss) + highlightSpecular;
    gl_FragColor.w = 1.0;
    
//    ADD_FOG(v_fog, fog_color);
//    COLOR_CORRECT;
    
//    gl_FragColor.xyz = result.xyz;
    

}
