//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec2 uv1;
attribute vec3 normal;
attribute vec4 color;


varying lowp vec4 v_color;
varying lowp float v_light_amt;

VARYING_MAT3(tangentSpace);

uniform lowp vec3 light_dir;
uniform mat4 mMatrix;
uniform mat4 vpMatrix;
uniform mat4 mvpMatrix;
uniform mat3 normalMatrix;

void main()
{
    vec3 w_normal = normalize(normalMatrix * normal);
    v_color = color;
    
    
    gl_Position = mvpMatrix * position;
    
    v_light_amt = max(0.0, dot(w_normal, normalize(light_dir)) - 0.1);

}
