//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec2 uv1;
attribute vec3 normal;

varying highp vec2 v_uv1;
varying highp vec3 v_normal;
varying highp vec3 v_view_dir;

uniform mat4 mvpMatrix;
uniform mat3 normalMatrix;
uniform highp mat4 viewInverse;
uniform highp mat4 mMatrix;

void main()
{
    gl_Position = mvpMatrix * position;
    v_uv1 = uv1;
    v_normal = normalMatrix * normal;
    v_view_dir = normalize(vec3(viewInverse * vec4(0.0, 0.0, 0.0, 1.0) - mMatrix * position));
}
