//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec2 uv1;

varying lowp vec2 v_uv1;

uniform mat4 tvpMatrix;
uniform mat2 rsMatrix;
uniform vec2 nearPlaneSize;

void main()
{
    vec4 center = tvpMatrix * vec4(0,0,0,1);
    gl_Position.xy = center.xy + rsMatrix * (position.xy * nearPlaneSize);
    gl_Position.zw = center.zw;
    
    v_uv1 = uv1;
}
