//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec4 color;
attribute vec2 uv1;
attribute vec4 normal; //center

varying lowp vec2 v_uv1;
varying lowp vec4 v_color;
varying lowp float v_fog;

uniform mat4 vpMatrix;
uniform vec2 nearPlaneSize;
uniform float fog_mult;
V_FOG_UNIFORMS

void main()
{
    vec4 center = vpMatrix * normal;
    gl_Position.xy = center.xy + (position.xy * nearPlaneSize);
    gl_Position.zw = center.zw;
    
    v_uv1 = uv1;
    v_color = color;
    
    v_fog = PARAM_FOG(fog_mult);
}
