//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//


varying lowp vec2 frag_uv1;
VARYING_MAT3(tangentSpace);
varying highp vec3 v_view_dir;

uniform lowp vec4 color;
uniform sampler2D texture;
uniform sampler2D normalMap;
uniform sampler2D gloss_map;

uniform highp mat4 viewInverse;
uniform highp mat4 mMatrix;
uniform highp mat4 vpMatrix;
uniform highp mat3 normalMatrix;

uniform lowp vec3 light_dir;

uniform lowp float ambient_mult;
uniform lowp float diffuse_mult;

F_FOG_UNIFORMS


void main()
{

//    lowp float pixel_size = 1.0/2048.0;
    lowp vec3 lightColor = vec3(1.0, 0.97, 0.9);
    lowp vec4 result = texture2D(texture, frag_uv1);
    lowp vec4 spec_gloss = texture2D(gloss_map, frag_uv1);
    lowp float gloss = spec_gloss.w;
    highp vec3 nm = normalize(texture2D(normalMap, frag_uv1).xyz*2.0 - 1.0).xyz;
    gl_FragColor = result;
    
    
    mediump vec3 normalDirection = normalize(MAKE_MAT3_FROM_VARYING(tangentSpace) * nm);
    lowp vec3 lightDirection = -normalize(light_dir);
    
    lowp float nDotVP = max(0.0, dot(normalDirection, normalize(lightDirection)));
    lowp float fresnel = 1.0 - pow(dot(normalDirection, v_view_dir), 1.0);
    
    lowp vec3 specularReflection;
    
    specularReflection = lightColor * (gloss*2.0*fresnel) * pow(max(0.0, dot(reflect(-lightDirection, normalDirection), v_view_dir)), 2.0);
    
    
    //lowp float refl_amt = gloss*fresnel;
    
    gl_FragColor.xyz = gl_FragColor.xyz*0.8*ambient_mult + vec3(0.9, 0.9, 1.0)*(fresnel*fresnel*0.2 + 0.02)*(1.0 - nDotVP) + (gl_FragColor.xyz + lightColor*0.3)*0.6*(nDotVP*diffuse_mult*lightColor + (specularReflection*gloss));
    gl_FragColor.w = 1.0;
    gl_FragColor *= color;

}
