//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

varying highp vec2 frag_uv1;
varying highp vec3 skybox_uv;

uniform sampler2D texture;
uniform samplerCube cubemap;

uniform mediump vec4 color;


void main()
{
    lowp vec4 result = texture2D(texture, frag_uv1) * color;
    lowp vec4 sky = textureCube(cubemap, normalize(skybox_uv));
    gl_FragColor = result + max(sky - vec4(0.5), vec4(0));
}
