//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec2 uv1;
attribute vec3 normal;
attribute vec4 binormal;

varying lowp vec2 frag_uv1;
varying lowp vec4 v_position;
varying lowp vec3 v_normal;
VARYING_MAT3(tangentSpace);

uniform mat4 mMatrix;
uniform mat4 vpMatrix;
uniform mat3 normalMatrix;


void main()
{
    vec3 n = normalize(normalMatrix * normal);
    vec3 t = normalize(normalMatrix * binormal.xyz);
    
    frag_uv1 = uv1;
    v_normal = normal;
    
    v_position = mMatrix * position;
    gl_Position = vpMatrix * v_position;

    vec3 b = -normalize(cross(n, t))*binormal.w;
    

    STORE_MAT3_VARYING(tangentSpace,
    t.x, t.y, t.z,
    b.x, b.y, b.z,
    n.x, n.y, n.z
    );

}
