//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//


varying highp vec2 frag_uv1;
varying highp float v_diff;
varying highp float v_spec;

uniform sampler2D texture;
uniform sampler2D specular_map;
uniform highp float ambient_mult;


void main()
{

    mediump vec3 lightColor = vec3(1.0, 0.93, 0.89);
    gl_FragColor = texture2D(texture, frag_uv1);
    lowp float specular = texture2D(specular_map, frag_uv1).x;

    gl_FragColor.xyz = gl_FragColor.xyz * (0.5*ambient_mult + 0.9*v_diff + v_spec*specular);
    gl_FragColor.w = 1.0;
    
    

}
