//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

varying highp vec2 frag_uv1;
varying lowp float v_norm;

uniform sampler2D texture;
uniform lowp vec4 color;
uniform lowp vec4 fill_color;
uniform lowp float fill_amt;

void main()
{
    lowp float mult = step(1.0 - v_norm, fill_amt);
    lowp float mult_inv = 1.0 - mult;
    lowp vec4 result = texture2D(texture, frag_uv1) * (color*mult_inv + fill_color*mult);
    gl_FragColor = result;
}
