//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

varying lowp vec2 v_uv1;

uniform sampler2D texture;
uniform lowp vec4 light_color;
uniform lowp vec4 dark_color;
uniform lowp vec4 color;

void main()
{
    lowp vec4 result = texture2D(texture, v_uv1);
    lowp vec4 inverse = vec4(1,1,1,1) - result;
    result *= light_color;
    result.xyz += dark_color.xyz*inverse.xyz;
    gl_FragColor = result*color;
}
